require 'morq/base'
require 'morq/list'

# LIST_QUERY(query): done - score.rb
# - get qresult... from query using inverted index
# - LIST_INDEX(qresult..., false)

# LIST_SIMILARITY(mid): - score.rb
# - get most significant words from mid using inverted index
# - get qresult... from words using inverted index
# - trim qresult... using score
# - LIST_INDEX(qresult..., thread=false)

module Morq::Score
  include Morq::List

  def eid_from_mid(mid)
    path = mid_path(mid)
    dbpath = morq_file("index")
    if false #true #
      require 'villa' # QDBM
      Villa.open(File.join(dbpath, "rdocs"), Villa::OREADER, Villa::CMPLEX) do |db|
        begin
          peid = db[path]
        rescue Villa::EANY
          return nil
        end
        return unpack_id(peid)
      end
    else
      estgeteid(dbpath, path)
    end
  end

  def stop_word(w)
    /^(?:||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||ˤ|ˤ|ˤ|Ҥ|Ҥ|Ҥ|ߤ|ߤ|ߤ||||||||||Ӥ|Ӥ|Ӥ|Ԥ|Ԥ|Ԥ|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||˥|˥|˥|ҥ|ҥ|ҥ|ߥ|ߥ|ߥ||||||||||ӥ|ӥ|ӥ|ԥ|ԥ|ԥ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||a|an|the|there|any|no|each|all|most|more|i|my|me|mine|you|your|yours|we|our|us|ours|he|his|him|she|her|hers|it|its|they|their|them|theirs|this|these|that|those|what|who|which|where|when|why|whose|how|or|and|but|not|as|if|so|because|as|unless|until|while|to|on|of|in|for|from|by|with|at|against|via|under|over|be|am|are|is|was|were|being|wanna|gonna|gotta|going|do|does|did|have|has|had|get|got|go|went|come|came|will|would|ll|can|could|may|might|shall|should|must|i'm|you're|re|it's|aren't|isn|isn't|don|don't|doesn|doesn't|didn|didn't|won|won't|wouldn|wouldn't|shouldn|shouldn't|mayn|mayn't|mustn|mustn't|ll|i'll|you'll|we'll|he'll|she'll|they'll|ve|i've|you've|we've|he've|she've|they've|i'd|you'd|he'd|she'd|they'd|ain't|haven't|hasn't|can't)$/e =~ w
  end
  def box_query(query)
    query.gsub!(/\s*[&+]\s*/, " &")
    query.gsub!(/\s*[|]\s*/, " |")
    query.gsub!(/\s*[!-]\s*/, " ~")
    data = ""
    query = query.split.collect do |q|
      if /^[&|~]/ =~ q
        prefix = $&
        q = $'
      end
      open("|kakasi -w", "w+") do |f|
        f.write(q)
        f.close_write
        q = f.read
      end
      q.split.delete_if{|qq| stop_word(qq)}
    end.flatten
    uri_list = estsearch(morq_file("index"), query)
    for uri in uri_list
      break unless /\/(\d+)$/ =~ uri
      data.concat pack_id(Integer($1))
    end
    Morq::List::Box.new(data, false)
  end
  def box_similarity(mid)
    raise RuntimeError, "Rast index does not support similarity search"
    dbpath = morq_file("index");
    data = estrelated(dbpath, File.join(dbpath, "_score"), eid_from_mid(mid))
    estkeywords(dbpath, File.join(dbpath, "_score"), eid_from_mid(mid))
    Morq::List::Box.new(data, false)
  end
end

if __FILE__ == $0
  include Morq::Score

#  p eid_from_mid(1)
  box_query("ڥ").list(STDOUT)
#  box_query("ޤĤ").list(STDOUT)
#  box_similarity(1).list(STDOUT)
end
